var ws= null;

var connectWebSocket= function() {
	ws= new WebSocket('ws://127.0.0.1:8091/websocket/chat','json'); // Server address / SPECIFICATION
	ws.onmessage= function(msg) { updateChat(msg); };
	
};

var sendAndClear= function(message) {
    if (message !== '') {
	    if (document.getElementById('send').innerHTML == 'Submit') {
		    ws.send(JSON.stringify({
		        action: 'register',
		        name: message
	        }));
	        
	        document.getElementById('message').placeholder= 'Type your message...';
	        document.getElementById('send').innerHTML= 'Send';
	        
	    } else {
	        ws.send(JSON.stringify({
		        message: message
	        }));
	        
	    }
	    
	    document.getElementById('message').value= '';
    }
};

var updateChat= function(msg) { // Update chat-panel and list of connected users
    var data= JSON.parse(msg.data);
    
    var htmlMessage= '<article><b>'+data.sender+' says:</b><span class="timestamp">'+data.timestamp+'</span><p>'+data.message+'</p></article>';
    
    document.getElementById('chatMessages').insertAdjacentHTML('afterbegin', htmlMessage);
    if (data.userlist) {
    	document.getElementById('listOfConnections').innerHTML= data.userlist.map(function(user) { return '<li>'+user+'</li>'; }).join('');
    }
};

document.getElementById('send').addEventListener('click', function(e) { sendAndClear(document.getElementById('message').value); });
document.getElementById('message').addEventListener('keypress', function (e) {
    if (e.keyCode === 13) { // Send message if enter is pressed in input field
        sendAndClear(e.target.value);
    }
});